LIBRARY LR;
USE LR.PackageLR.all;


ENTITY LancerRayon IS

	PORT (	Px, Py, Pz 	: IN INTEGER;	-- Coordonnes de l'observation
		Dx, Dy, Dz 	: IN INTEGER;	-- Vecteur de rayon
		Vx, Vy, Vz 	: IN INTEGER;	-- Coordonnes du centre de la sphere
		Rcarre 		: IN INTEGER;	-- Carre du rayon de la sphere
		lambda 		: OUT INTEGER;	-- distance de l'intersection
		debut 		: IN bit);	-- signal de declenchement du calcul

END LancerRayon;

ARCHITECTURE comportement OF LancerRayon IS


BEGIN
	PROCESS (debut)
		VARIABLE X, Y, Z : INTEGER ; 
		VARIABLE B, C, Delta : INTEGER ; 	
		VARIABLE RDelta, l1, l2 : INTEGER; 	
	BEGIN 	
		X := 0 - Vx;
		Y := 0 - Vy;
		Z := Pz - Vz;
		
		B := X * Dx + Y * Dy + Z * Dz;		
		C := X * X + Y * Y + Z * Z - Rcarre;
		
		Delta := B * B - C;
		
		RDelta := SQRINT(Delta);
		l1 := 0 - RDelta - B;
		l2 :=     RDelta - B;
		
		lambda <= MINIMUM(l1,l2);
 
	END PROCESS;

END comportement;


