library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;


PACKAGE PackageLR IS

	CONSTANT Tclock : TIME := 30 ns;
	CONSTANT Tacces : TIME := 150 ns;

	SUBTYPE INT8BITS IS INTEGER RANGE -128 TO 127;

	SUBTYPE INT16BITS IS INTEGER RANGE -32768 TO 32767;

	SUBTYPE BitVector3 IS signed(2 DOWNTO 0);

	SUBTYPE BitVector8 IS signed(7 DOWNTO 0);

	SUBTYPE BitVector16 IS signed(15 DOWNTO 0);

	SUBTYPE BitVector32 IS signed(31 DOWNTO 0);
	
	FUNCTION SQRVFCG (Valeur : IN INTEGER) RETURN INTEGER ; 
	
	FUNCTION SQRINT (Valeur : IN INTEGER) RETURN INTEGER ; 
	
	FUNCTION MINIMUM (Valeur1 : IN INTEGER ; Valeur2 : IN INTEGER) RETURN INTEGER ; 

END PackageLR ;


PACKAGE BODY PackageLR IS

	FUNCTION MINIMUM (Valeur1 : IN INTEGER ; Valeur2 : IN INTEGER) RETURN INTEGER IS

		VARIABLE min : INTEGER;

	BEGIN
		IF (Valeur1 > 0) AND (Valeur2 > 0) THEN
		    IF (Valeur1 < Valeur2) THEN
			min := Valeur1;
		    ELSE 
			min := Valeur2;
		    END IF;
		ELSIF (Valeur1 > 0) THEN
		    min := Valeur1;
		ELSIF (Valeur2 > 0) THEN
		    min := Valeur2;
		ELSE
		    min := 0;
		END IF;
		RETURN min;
	END MINIMUM;
	
	FUNCTION SQRINT (Valeur : IN INTEGER) RETURN INTEGER IS

		VARIABLE racine : INTEGER;

	BEGIN

	case Valeur is
         	When  0 => Racine := 0 ;
                When 1 To 2 => Racine := 1 ;
                When 3 To 6 => Racine := 2 ;
                When 7 To 12 => Racine := 3 ;
                When 13 To 20 => Racine := 4 ;
                When 21 To 30 => Racine := 5 ;
                When 31 To 42 => Racine := 6 ;
                When 43 To 56 => Racine := 7 ;
                When 57 To 72 => Racine := 8 ;
                When 73 To 90 => Racine := 9 ;
                When 91 To 110 => Racine := 10 ;
                When 111 To 132 => Racine := 11 ;
                When 133 To 156 => Racine := 12 ;
                When 157 To 182 => Racine := 13 ;
                When 183 To 210 => Racine := 14 ;
                When 211 To 240 => Racine := 15 ;
                When 241 To 272 => Racine := 16 ;
                When 273 To 306 => Racine := 17 ;
                When 307 To 342 => Racine := 18 ;
                When 343 To 380 => Racine := 19 ;
                When 381 To 420 => Racine := 20 ;
                When 421 To 462 => Racine := 21 ;
                When 463 To 506 => Racine := 22 ;
                When 507 To 552 => Racine := 23 ;
                When 553 To 600 => Racine := 24 ;
                When 601 To 650 => Racine := 25 ;
                When 651 To 702 => Racine := 26 ;
                When 703 To 756 => Racine := 27 ;
                When 757 To 812 => Racine := 28 ;
                When 813 To 870 => Racine := 29 ;
                When 871 To 930 => Racine := 30 ;
                When 931 To 992 => Racine := 31 ;
                When 993 To 1056 => Racine := 32 ;
                When 1057 To 1122 => Racine := 33 ;
                When 1123 To 1190 => Racine := 34 ;
                When 1191 To 1260 => Racine := 35 ;
                When 1261 To 1332 => Racine := 36 ;
                When 1333 To 1406 => Racine := 37 ;
                When 1407 To 1482 => Racine := 38 ;
                When 1483 To 1560 => Racine := 39 ;
                When 1561 To 1640 => Racine := 40 ;
                When 1641 To 1722 => Racine := 41 ;
                When 1723 To 1806 => Racine := 42 ;
                When 1807 To 1892 => Racine := 43 ;
                When 1893 To 1980 => Racine := 44 ;
                When 1981 To 2070 => Racine := 45 ;
                When 2071 To 2162 => Racine := 46 ;
                When 2163 To 2256 => Racine := 47 ;
                When 2257 To 2352 => Racine := 48 ;
                When 2353 To 2450 => Racine := 49 ;
                When 2451 To 2550 => Racine := 50 ;
                When 2551 To 2652 => Racine := 51 ;
                When 2653 To 2756 => Racine := 52 ;
                When 2757 To 2862 => Racine := 53 ;
                When 2863 To 2970 => Racine := 54 ;
                When 2971 To 3080 => Racine := 55 ;
                When 3081 To 3192 => Racine := 56 ;
                When 3193 To 3306 => Racine := 57 ;
                When 3307 To 3422 => Racine := 58 ;
                When 3423 To 3540 => Racine := 59 ;
                When 3541 To 3660 => Racine := 60 ;
                When 3661 To 3782 => Racine := 61 ;
                When 3783 To 3906 => Racine := 62 ;
                When 3907 To 4032 => Racine := 63 ;
                When 4033 To 4160 => Racine := 64 ;
                When 4161 To 4290 => Racine := 65 ;
                When 4291 To 4422 => Racine := 66 ;
                When 4423 To 4556 => Racine := 67 ;
                When 4557 To 4692 => Racine := 68 ;
                When 4693 To 4830 => Racine := 69 ;
                When 4831 To 4970 => Racine := 70 ;
                When 4971 To 5112 => Racine := 71 ;
                When 5113 To 5256 => Racine := 72 ;
                When 5257 To 5402 => Racine := 73 ;
                When 5403 To 5550 => Racine := 74 ;
                When 5551 To 5700 => Racine := 75 ;
                When 5701 To 5852 => Racine := 76 ;
                When 5853 To 6006 => Racine := 77 ;
                When 6007 To 6162 => Racine := 78 ;
                When 6163 To 6320 => Racine := 79 ;
                When 6321 To 6480 => Racine := 80 ;
                When 6481 To 6642 => Racine := 81 ;
                When 6643 To 6806 => Racine := 82 ;
                When 6807 To 6972 => Racine := 83 ;
                When 6973 To 7140 => Racine := 84 ;
                When 7141 To 7310 => Racine := 85 ;
                When 7311 To 7482 => Racine := 86 ;
                When 7483 To 7656 => Racine := 87 ;
                When 7657 To 7832 => Racine := 88 ;
                When 7833 To 8010 => Racine := 89 ;
                When 8011 To 8190 => Racine := 90 ;
                When 8191 To 8372 => Racine := 91 ;
                When 8373 To 8556 => Racine := 92 ;
                When 8557 To 8742 => Racine := 93 ;
                When 8743 To 8930 => Racine := 94 ;
                When 8931 To 9120 => Racine := 95 ;
                When 9121 To 9312 => Racine := 96 ;
                When 9313 To 9506 => Racine := 97 ;
                When 9507 To 9702 => Racine := 98 ;
                When 9703 To 9900 => Racine := 99 ;
                When 9901 To 10100 => Racine := 100 ;
                When 10101 To 10302 => Racine := 101 ;
                When 10303 To 10506 => Racine := 102 ;
                When 10507 To 10712 => Racine := 103 ;
                When 10713 To 10920 => Racine := 104 ;
                When 10921 To 11130 => Racine := 105 ;
                When 11131 To 11342 => Racine := 106 ;
                When 11343 To 11556 => Racine := 107 ;
                When 11557 To 11772 => Racine := 108 ;
                When 11773 To 11990 => Racine := 109 ;
                When 11991 To 12210 => Racine := 110 ;
                When 12211 To 12432 => Racine := 111 ;
                When 12433 To 12656 => Racine := 112 ;
                When 12657 To 12882 => Racine := 113 ;
                When 12883 To 13110 => Racine := 114 ;
                When 13111 To 13340 => Racine := 115 ;
                When 13341 To 13572 => Racine := 116 ;
                When 13573 To 13806 => Racine := 117 ;
                When 13807 To 14042 => Racine := 118 ;
                When 14043 To 14280 => Racine := 119 ;
                When 14281 To 14520 => Racine := 120 ;
                When 14521 To 14762 => Racine := 121 ;
                When 14763 To 15006 => Racine := 122 ;
                When 15007 To 15252 => Racine := 123 ;
                When 15253 To 15500 => Racine := 124 ;
                When 15501 To 15750 => Racine := 125 ;
                When 15751 To 16002 => Racine := 126 ;
                When 16003 To 16256 => Racine := 127 ;
		when others => Racine := 0 ;
		end case; 
		RETURN racine;
	END SQRINT ;
	
	FUNCTION SQRVFCG (Valeur : IN INTEGER) RETURN INTEGER IS

		VARIABLE racine : INTEGER;

	BEGIN

		case Valeur is
                when  0 => racine:=  0 ;
                when  1 => racine:=  2 ;
                when  2 to  3 => racine:=  3 ;
                when  4 to  5 => racine:=  4 ;
                when  6 to  7 => racine:=  5 ;
                when  8 to 10 => racine:=  6 ;
                when 11 to 14 => racine:=  7 ;
                when 15 to 18 => racine:=  8 ;
                when 19 to 22 => racine:=  9 ;
                when 23 to 27 => racine:= 10 ;
                when 28 to 33 => racine:= 11 ;
                when 34 to 39 => racine:= 12 ;
                when 40 to 45 => racine:= 13 ;
                when 46 to 52 => racine:= 14 ;
                when 53 to 60 => racine:= 15 ;
                when 61 to 68 => racine:= 16 ;
                when 69 to 76 => racine:= 17 ;
                when 77 to 85 => racine:= 18 ;
                when 86 to 95 => racine:= 19 ;
                when 96 to 105 => racine:= 20 ;
                when 106 to 115 => racine:= 21 ;
                when 116 to 126 => racine:= 22 ;
                when 127 to 138 => racine:= 23 ;
                when 139 to 150 => racine:= 24 ;
                when 151 to 162 => racine:= 25 ;
                when 163 to 175 => racine:= 26 ;
                when 176 to 189 => racine:= 27 ;
                when 190 to 203 => racine:= 28 ;
                when 204 to 217 => racine:= 29 ;
                when 218 to 232 => racine:= 30 ;
                when 233 to 248 => racine:= 31 ;
                when 249 to 264 => racine:= 32 ;
                when 265 to 280 => racine:= 33 ;
                when 281 to 297 => racine:= 34 ;
                when 298 to 315 => racine:= 35 ;
                when 316 to 333 => racine:= 36 ;
                when 334 to 351 => racine:= 37 ;
                when 352 to 370 => racine:= 38 ;
                when 371 to 390 => racine:= 39 ;
                when 391 to 410 => racine:= 40 ;
                when 411 to 430 => racine:= 41 ;
                when 431 to 451 => racine:= 42 ;
                when 452 to 473 => racine:= 43 ;
                when 474 to 495 => racine:= 44 ;
                when 496 to 517 => racine:= 45 ;
                when 518 to 540 => racine:= 46 ;
                when 541 to 564 => racine:= 47 ;
                when 565 to 588 => racine:= 48 ;
                when 589 to 612 => racine:= 49 ;
                when 613 to 637 => racine:= 50 ;
                when 638 to 663 => racine:= 51 ;
                when 664 to 689 => racine:= 52 ;
                when 690 to 715 => racine:= 53 ;
                when 716 to 742 => racine:= 54 ;
                when 743 to 770 => racine:= 55 ;
                when 771 to 798 => racine:= 56 ;
                when 799 to 826 => racine:= 57 ;
                when 827 to 855 => racine:= 58 ;
                when 856 to 885 => racine:= 59 ;
                when 886 to 915 => racine:= 60 ;
                when 916 to 945 => racine:= 61 ;
                when 946 to 976 => racine:= 62 ;
                when 977 to 1008 => racine:= 63 ;
                when 1009 to 1040 => racine:= 64 ;
                when 1041 to 1072 => racine:= 65 ;
                when 1073 to 1105 => racine:= 66 ;
                when 1106 to 1139 => racine:= 67 ;
                when 1140 to 1173 => racine:= 68 ;
                when 1174 to 1207 => racine:= 69 ;
                when 1208 to 1242 => racine:= 70 ;
                when 1243 to 1278 => racine:= 71 ;
                when 1279 to 1314 => racine:= 72 ;
                when 1315 to 1350 => racine:= 73 ;
                when 1351 to 1387 => racine:= 74 ;
                when 1388 to 1425 => racine:= 75 ;
                when 1426 to 1463 => racine:= 76 ;
                when 1464 to 1501 => racine:= 77 ;
                when 1502 to 1540 => racine:= 78 ;
                when 1541 to 1580 => racine:= 79 ;
                when 1581 to 1620 => racine:= 80 ;
                when 1621 to 1660 => racine:= 81 ;
                when 1661 to 1701 => racine:= 82 ;
                when 1702 to 1743 => racine:= 83 ;
                when 1744 to 1785 => racine:= 84 ;
                when 1786 to 1827 => racine:= 85 ;
                when 1828 to 1870 => racine:= 86 ;
                when 1871 to 1914 => racine:= 87 ;
                when 1915 to 1958 => racine:= 88 ;
                when 1959 to 2002 => racine:= 89 ;
                when 2003 to 2047 => racine:= 90 ;
                when 2048 to 2093 => racine:= 91 ;
                when 2094 to 2139 => racine:= 92 ;
                when 2140 to 2185 => racine:= 93 ;
                when 2186 to 2232 => racine:= 94 ;
                when 2233 to 2280 => racine:= 95 ;
                when 2281 to 2328 => racine:= 96 ;
                when 2329 to 2376 => racine:= 97 ;
                when 2377 to 2425 => racine:= 98 ;
                when 2426 to 2475 => racine:= 99 ;
                when 2476 to 2525 => racine:= 100 ;
                when 2526 to 2575 => racine:= 101 ;
                when 2576 to 2626 => racine:= 102 ;
                when 2627 to 2678 => racine:= 103 ;
                when 2679 to 2730 => racine:= 104 ;
                when 2731 to 2782 => racine:= 105 ;
                when 2783 to 2835 => racine:= 106 ;
                when 2836 to 2889 => racine:= 107 ;
                when 2890 to 2943 => racine:= 108 ;
                when 2944 to 2997 => racine:= 109 ;
                when 2998 to 3052 => racine:= 110 ;
                when 3053 to 3108 => racine:= 111 ;
                when 3109 to 3164 => racine:= 112 ;
                when 3165 to 3220 => racine:= 113 ;
                when 3221 to 3277 => racine:= 114 ;
                when 3278 to 3335 => racine:= 115 ;
                when 3336 to 3393 => racine:= 116 ;
                when 3394 to 3451 => racine:= 117 ;
                when 3452 to 3510 => racine:= 118 ;
                when 3511 to 3570 => racine:= 119 ;
                when 3571 to 3630 => racine:= 120 ;
                when 3631 to 3690 => racine:= 121 ;
                when 3691 to 3751 => racine:= 122 ;
                when 3752 to 3813 => racine:= 123 ;
                when 3814 to 3875 => racine:= 124 ;
                when 3876 to 3937 => racine:= 125 ;
                when 3938 to 4000 => racine:= 126 ;
                when 4001 to 4095 => racine:= 127 ;
		when others => racine:=0 ;
		end case; 
		RETURN racine;
	END SQRVFCG ;

END PackageLR ;
